/* ======================================================================
       Program.................TECHINF.EXE
       Author..................D.Gannon
       Date....................7th July 1994
       Written.................Turbo C/C++ 3.00

       Description....Produces a listing of hardware/software
		      details to screen. Supports redirection ( eg. >PRN )
   =====================================================================*/

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <bios.h>
#include <dos.h>

#include <dg_dos.h>
#include <cmos.h>


#define BIOSDATE_SEG 0xF000
#define BIOSDATE_OFS 0xFFF5
#define VERSION "1.00"


 // declare prototypes for the procedures

 void get_partition_info( int drive_number, struct partition_sector buffer );
  int get_boot_info(int drive, int sector, int track, int head);
  int type_file(char *filename);
  int get_model(void);
  int get_bios_equiplist(void);
  int get_share_status(void);
  int get_romdate(void);
  int get_feature(unsigned char *feature);
  int get_basemem(void);
  int get_cmos_info(void);
 void get_ext_params(int port);



main(void)
{
  struct partition_sector buffer;

   char *autoexec = "c:\\autoexec.bat";
   char *config = "c:\\config.sys";

   int num_of_floppy_drives = 0,
       num_of_hard_drives   = 0;
   int count,result;

    printf(" TECHINF.EXE        Version %s      1994 D.Gannon\n\r\n\r",VERSION);
    printf("------------ BIOS ID INFORMATION ----------------\n\r\n\r");

   // get BIOS ID bytes
    get_model();
   // get BIOS date
    get_romdate();
   // get OS version  ...not in use yet
    printf("\r\n");


   /* get number of serial & parallel ports
      get MCA status, co-processor status &
      share status */
    get_bios_equiplist();
    get_share_status();
    // get amount of base memory
    get_basemem();

   // get number of floppy drives
    num_of_floppy_drives =  get_number_of_drives(FLOPPY_DRIVE);

   // get number of physical h/drive(s)
    num_of_hard_drives =  get_number_of_drives(HARD_DRIVE);

   // print details of hard drive(s)
    printf("\r\n------------ DRIVE INFORMATION ------------------\n\r\n\r");
    printf( "     Total Floppy drives : %d\n\r",num_of_floppy_drives );
    printf( " Total physical H/drives : %d\n\r",num_of_hard_drives );

    for(count = 0; count <= (num_of_hard_drives - 1); count++)
     {
      printf("\n\r       PHYSICAL PROPERTIES FOR H/DRIVE %d",count +1);
      get_drive_parameters( HARD_DRIVE + count );
       result = biosdisk( 2, ( HARD_DRIVE + count ), 0, 0, 1, 1, &buffer);

      // get partition information
      if (result == 0 )
	{
	 printf("\r\n--- PARTITION INFORMATION FOR H/DRIVE %d --------\n\r\n\r",count + 1 );
	 printf("Active       Starting      System        Ending       Relative  Total Sectors\n\r");
	 printf(" Y/N    Head  Cyl  Sect     Ind      Head  Cyl  Sect   Sectors  in Partition\n\r");

	 get_partition_info( count, buffer );
	 printf("\r\n");
	}
    }


    // print details of floppy drive(s)
    for(count = 0; count <= (num_of_floppy_drives - 1); count++)
     {
      printf("\n\r     PHYSICAL PROPERTIES FOR FLOPPY/DRIVE %d",count +1);
      get_drive_parameters( FLOPPY_DRIVE + count );
     }

   // get mouse status  ..not in use

   get_cmos_info();
   // get contents of autoexec.bat file
    type_file(autoexec);
   // get contents of config.sys file
    type_file(config);


 return 0;
}



// ****************** all procedures start here ************************

/*  bit mask for BIOS equipment list

    Number of parallel printers installed:
                         00 = 0; 01 = 1; 10 = 2; 11 = 3
       Serial printer attached
         Game I/O attached
              Number of COM ports: 000 = 0, 001 = 1,..., 111 = 7
                   Direct memory access (DMA)
                     0 = Machine has DMA; 1 = Machine doesn't have DMA
ͻ
151413121110 9 8 7 6 5 4 3 2 1 0
ͼ
Number of disk drives:                  
  00 = 0; 01 = 1; 10 = 2; 11 = 3            
Initial video mode             
  00 = Unused                                
  01 = 40 x 25 BW with color card            
  10 = 80 x 25 BW with color card            
  11 = 80 x 25 BW with mono card             
Motherboard RAM size        
  00 = 16K; 01 = 32K; 10 = 48K; 11 = 64K      
Floating-point coprocessor    
Boot from disk  
*/

 get_bios_equiplist(void)
  {
    int equipment = 0;
    int serval;
    int BOOT_FROM_DISK = 0x0001,
	CO_PROCESSOR   = 0x0002,
	VIDEO          = 0x0030,
	SERIAL         = 0x0e00,
	PARALLEL       = 0xC000;

      equipment = biosequip();

    printf("------------ BIOS equipment list ---------------\n\r\n\r");
    printf("    Floppy Drive present : ");
      if (equipment & BOOT_FROM_DISK) printf( "yes\r\n" );
      else printf("no\r\n");
    printf("        Math CoProcessor : ");
      if (equipment & CO_PROCESSOR)   printf( "installed\r\n" );
      else printf("not installed\r\n");
    printf("              Video Mode : ");
      switch( equipment & VIDEO)
       {
	 case 0x0010: printf( "40x25 BW,colour adapter\r\n" );
		 break;
	 case 0x0020: printf( "80x25, colour adapter\r\n" );
		 break;
	 case 0x0030: printf( "80x25, monochrome adapter\r\n" );
		 break;
	  default:printf("unused\r\n");
	}

    printf("            Serial Ports : ");

      switch ( equipment & SERIAL )
       {
	case 0x0200: printf("1\r\n");
		 break;
	case 0x0400: printf("2\r\n");
		 break;
	case 0x0600: printf("3\r\n");
		 break;
	case 0x0800: printf("4\r\n");
		 break;
	case 0x0A00: printf("5\r\n");
		 break;
	case 0x0C00: printf("6\r\n");
		 break;
	case 0x0E00: printf("7\r\n");
		 break;
	    default: printf("none\r\n");
       }

    printf("          Parallel Ports : ");

      switch ( equipment & PARALLEL )
       {
	case 0x4000: printf("1\r\n");
		 break;
	case 0x8000: printf("2\r\n");
		 break;
	case 0xA000: printf("3\r\n");
		 break;
	    default: printf("none\r\n");
       }

   return 0;
  }



 get_share_status(void)
  {
     int share;
    union REGS regs;


     regs.h.ah = 0x10;           // invoke ROM BIOS function 10H
     regs.h.al = 0x00;          // request details for 1st drive
     int86(0x2f, &regs, &regs);

     share = regs.h.al;

    printf("            SHARE status : ");

     if(share==0x00) printf("not loaded\r\n");
     if(share==0xff) printf("loaded\r\n");


   return 0;
  }


 get_romdate(void)
  {
   char romdate[9] = {0};

   movedata( BIOSDATE_SEG, BIOSDATE_OFS, FP_SEG(romdate), FP_OFF(romdate), 8);
    printf("               BIOS Date : ");
    printf("%s\r\n",romdate);

   return 0;
  }



/*  bit mask for feature byte

	   Fixed disk BIOS uses DMA 3: 0 = No; 1 = Yes
	     Cascaded IRQ 2 : 0 = No; 1 = Yes
	       Real Time Clock : 0 = No; 1 = Yes
	              Extended BIOS data area: 0 = No; 1 = Yes
	                    Reserved
	                   
	ͻ
	 7 6 5 4 3 2 1 0
	ͼ
		          
		          
 Keyboard intercept        
  0 = No; 1 = Yes          
		           
 Wait for external event    
  0 = No;1 = Yes	   Micro Channel Bus : 0 = No; 1 = Yes

*/

 get_feature(unsigned char *feature)
  {

    printf("       Micro Channel Bus : ");
   if (feature[0] & 0x02) printf("Present\r\n");
   else printf("Not Present\r\n");

    printf(" Extended BIOS Data area : ");
   if (feature[0] & 0x04) printf("Allocated\r\n");
   else printf("Not Allocated\r\n");

    printf(" Wait for external event : ");
   if (feature[0] & 0x08) printf("Supported\r\n");
   else printf("Not Supported\r\n");

    printf(" BIOS keyboard intercept : ");
   if (feature[0] & 0x10) printf("Yes\r\n");
   else printf("No\r\n");

    printf("         Real time Clock : ");
   if (feature[0] & 0x20) printf("Present\r\n");
   else printf("Not Present\r\n");

    printf("          Cascaded IRQ 2 : ");
   if (feature[0] & 0x40) printf("Yes\r\n");
   else printf("No\r\n");

    printf("   Fixed Disk BIOS DMA 3 : ");
   if (feature[0] & 0x80) printf("Yes\r\n");
   else printf("No\r\n");


  return 0;
 }


 get_model(void)
  {
	    struct REGPACK reg;
	       int seg,ofs;
     unsigned char model[2] = "\0";
     unsigned char submodel[2] = "\0";
     unsigned char revision[2] = "\0";
     unsigned char feature[2] = "\0";

     reg.r_ax = 0xC0 << 8;         /* shift 3Bh into  AH */
     intr(0x15, &reg);

     seg = reg.r_es;
     ofs = reg.r_bx;

   movedata( seg, (ofs+2), FP_SEG(model),FP_OFF(model), 1);
   movedata( seg, (ofs+3), FP_SEG(submodel),FP_OFF(submodel), 1);
   movedata( seg, (ofs+4), FP_SEG(revision),FP_OFF(revision), 1);
   movedata( seg, (ofs+5), FP_SEG(feature),FP_OFF(feature), 1);


    printf("                ID Bytes : ");
    printf("%02X %02X %02X %02X\r\n",model[0],submodel[0],revision[0],feature[0]);

    printf("              Model Name : ");

   if( (( model[0]==0xF8) && (submodel[0] == 0x00)) && (revision[0] == 0x00))
    printf("PS/2 Model 80/16MHz\r\n");
   if( (( model[0]==0xF8) && (submodel[0] == 0x01)) && (revision[0] == 0x00))
    printf("PS/2 Model 80/20MHz\r\n");

   if( (( model[0]==0xF9) && (submodel[0] == 0x00)) && (revision[0] == 0x00))
    printf("PC Convertible\r\n");

   if( (( model[0]==0xFA) && (submodel[0] == 0x00)) && (revision[0] == 0x00))
    printf("PS/2 Model 30\r\n");
   if( (( model[0]==0xFA) && (submodel[0] == 0x01)) && (revision[0] == 0x00))
    printf("PS/2 Model 25\r\n");

   if( (( model[0]==0xFB) && (submodel[0] == 0x00)) && (revision[0] == 0x00))
    printf("PC/XT\r\n");

   if( (( model[0]==0xFC) && (submodel[0] == 0x00)) && (revision[0] == 0x00))
    printf("PC/AT\r\n");
   if( (( model[0]==0xFC) && (submodel[0] == 0x01)) && (revision[0] == 0x00))
    printf("PC/AT\r\n");
   if( (( model[0]==0xFC) && (submodel[0] == 0x02)) && (revision[0] == 0x00))
    printf("PC/XT 286\r\n");
   if( (( model[0]==0xFC) && (submodel[0] == 0x04)) && (revision[0] == 0x00))
    printf("PS/2 Model 50\r\n");
   if( (( model[0]==0xFC) && (submodel[0] == 0x04)) && (revision[0] == 0x03))
    printf("PS/2 Model 50/z\r\n");
   if( (( model[0]==0xFC) && (submodel[0] == 0x05)) && (revision[0] == 0x00))
    printf("PS/2 Model 60\r\n");

   if( (( model[0]==0xFD) && (submodel[0] == 0x00)) && (revision[0] == 0x00))
    printf("PCjr\r\n");

   if( (( model[0]==0xFF) && (submodel[0] == 0x00)) && (revision[0] == 0x00))
    printf("PC\r\n");

    get_feature(&feature[0]);

  return 0;
 }




 // routine for typing contents of a file
 type_file(char *filename)
  {
   FILE *infile;
   char one_line[80];

    printf("\r\n");

    if( (infile = fopen (filename,"rt") )  == NULL )
      {
       printf("------------ %12s file not found --------------\n\r\n\r",filename);
       return 1;
       }

       printf("----------- Contents of %12s file -------------\n\r\n\r",filename);
    while ( !feof (infile) )
     {
      if( fgets(one_line,126,infile) )
       printf("%s",one_line);

     }
    fclose(infile);
    printf("\r\n");
   return 0;
  }


 get_number_of_drives(int drive_number)
  {
    union REGS regs;

    int physical_drives;
    int error_num;

     regs.h.ah = 0x08;          // invoke ROM BIOS function 08H
     regs.h.dl = drive_number;          // request details for 1st drive
     int86(0x13, &regs, &regs);

     if(regs.x.cflag != 0)
     {
       return(0);
     }
     else  physical_drives          = regs.h.dl;

   return (physical_drives);
  }


 int get_drive_parameters( int drive_number)
  {
	   union REGS regs;

	     int error_num;
    unsigned int cyls_hi,cyls_lo;
	    long cylinders            = 0,
		 sectors_per_cylinder = 0,
		 heads                = 0,
		 total_sectors        = 0;
	   float total_size           = 0;


     regs.h.ah = 0x08;          // invoke ROM BIOS function 08H
     regs.h.dl = drive_number;          // request details for 1st drive
     int86(0x13, &regs, &regs);

     if( regs.x.cflag != 0 )
     {
       cprintf("error");
     }
     else
      {
       cyls_hi               = ( ( regs.h.cl ) & 0xC0 );
       cyls_lo               =   regs.h.ch;
       sectors_per_cylinder  = ( regs.h.cl & 0x3F );
       heads                 = ( regs.h.dh ) + 1;

       cylinders       = ( ( cyls_hi << 2) + cyls_lo ) + 1;
       total_sectors   = ( cylinders * sectors_per_cylinder ) * heads;
       total_size      = (float)(  total_sectors * BYTES_PER_SECTOR ) / MEGABYTE;

       printf("\n\r                cylinders: %d", cylinders );
       printf("\n\r     sectors per cylinder: %d", sectors_per_cylinder);
       printf("\n\r                    heads: %d", heads);
       printf("\n\r            total sectors: %ld", total_sectors);
       printf("\n\r                Size (Mb): %.1f", total_size);
       printf("\n\r");
      }

   return (0);
  }


 void get_partition_info( int drive_number, struct partition_sector buffer )
  {
     int count;
     int start_head,
	 start_cylinder_hi,
	 start_cylinder_lo,
	 start_cylinder,
	 start_sector;
     int end_head,
	 end_cylinder_hi,
	 end_cylinder_lo,
	 end_cylinder,
	 end_sector;


       for( count = 0; count <= ( NUM_PARTITIONS - 1 ); count++ )
	 {
	  switch( buffer.partition_table[count].active )
	    {
	     case 0x80:printf(" Yes ");
		       break;
	       default:printf(" No  ");
	    }

	  start_head        = buffer.partition_table[count].start[0];
	  start_cylinder_hi = ( (buffer.partition_table[count].start[1] &0xc0 ) << 2);
	  start_cylinder_lo = ( buffer.partition_table[count].start[2]);
	  start_cylinder    =  start_cylinder_hi + start_cylinder_lo;
	  start_sector      = ( ( buffer.partition_table[count].start[1] ) & 0x3f);

	  printf("   %3d   %3d  %3d   ",start_head, start_cylinder, start_sector);


	  switch( buffer.partition_table[count].sys_indicator )
	    {
	     case 0:printf(" Unknown ");
		    break;
	     case 1:printf("DOS-12bit");
		    break;
	     case 2:printf("  XENIX  ");
		    break;
	     case 4:printf("DOS-16bit");
		    break;
	     case 5:printf("DOS-extnd");
		    break;
	     case 6:printf("DOS->32Mb");
		    break;
	    default:printf(" Unknown ");
	    }


	  end_head        = buffer.partition_table[count].end[0];
	  end_cylinder_hi = ( (buffer.partition_table[count].end[1] &0xc0 ) << 2);
	  end_cylinder_lo = ( buffer.partition_table[count].end[2]);
	  end_cylinder    =  end_cylinder_hi + end_cylinder_lo;
	  end_sector      = ( ( buffer.partition_table[count].end[1] ) & 0x3f);

	  printf("   %3d  %3d  %3d   ",end_head, end_cylinder, end_sector);

	  printf(" %8ld      ",buffer.partition_table[count].relative_sect);
	  printf("%8ld\r\n",buffer.partition_table[count].total_sectors);

	  if(buffer.partition_table[count].total_sectors > 0)
	   get_boot_info(drive_number, start_head, start_cylinder, start_sector);

	 }

  }


 get_boot_info(int drive, int head, int track, int sector)
  {
   struct boot boot_buffer;
      int result  = 0;
      int count   = 0,
	  retry   = 0;

   printf("                   BOOT SECTOR INFO. FOR PARTITION");
   while(retry < 2)
   {
   result = biosdisk( 2, ( 0x80 + drive ), head, track, sector, 1, &boot_buffer);

   if ( result == 0 )
    {
     printf( "\r\n              Program code : ");

     for(count=0;count <=2;count++)
     {
      printf("%02X ", boot_buffer.reserved[count] );
      }

     printf( "\r\n                  OEM name : %s", boot_buffer.OEM_name);
     printf( "\r\n          Bytes per sector : %d", boot_buffer.bytes_per_sector);
     printf( "\r\n       Sectors per cluster : %d", boot_buffer.sectors_per_cluster);
     printf( "\r\n          Reserved Sectors : %d", boot_buffer.reserved_sectors);
     printf( "\r\n           Number of FAT's : %d", boot_buffer.num_of_fats);
     printf( "\r\nMax root Directory entries : %d", boot_buffer.num_of_root_dir);
     printf( "\r\n Number of logical sectors : %u", boot_buffer.num_of_log_sectors);
     printf( "\r\n     Media Descriptor byte : %02X", boot_buffer.media_descriptor);
     printf( "\r\n           Sectors per FAT : %d", boot_buffer.sectors_per_fat);
     printf( "\r\n         Sectors per track : %d", boot_buffer.sectors_per_track);
     printf( "\r\n           Number of heads : %d", boot_buffer.heads);
     printf( "\r\n  Number of hidden sectors : %d", boot_buffer.hidden_sectors);
     printf( "\r\n\r\n");

     retry = 3;
    }
    else retry++;

   }
     if(retry <= 2) printf ( "Error %02X \r\n",result);

  return 0;
 }




 get_basemem(void)
  {
      int mem;
    union REGS regs;

     int86(0x12, &regs, &regs);

     mem = regs.x.ax;

    printf("             Base Memory : %dKb\r\n",mem);

   return 0;
  }


 get_cmos_info(void)
 {
   int second,minute,hour,
       day,month,year;
   int floppy,hdbyte,hdrive2;
   int hdext;
   int basemem_lo,basemem_hi,basemem;
  long extmem_lo,extmem_hi,extmem;

    printf("\r\n\r\n------------ CMOS RAM INFO.----------------------\n\r\n\r");

  // see cmos.h for names

  // get time
  outp ( CM_OUTPORT, CM_SEC );
   second = inp ( CM_INPORT );
  outp ( CM_OUTPORT, CM_MIN );
   minute = inp ( CM_INPORT );
  outp ( CM_OUTPORT, CM_HOUR );
   hour = inp ( CM_INPORT );

  // get date
  outp ( CM_OUTPORT, CM_DAY_OF_MONTH );
   day = inp ( CM_INPORT );
  outp ( CM_OUTPORT, CM_MONTH );
   month = inp ( CM_INPORT );
  outp ( CM_OUTPORT, CM_YEAR );
   year = inp ( CM_INPORT );

    printf("                   Time : %02X:%02X:%02X\r\n",hour,minute,second);
    printf("                   Date : %02X-%02X-%02X\r\n",day,month,year);


  outp ( CM_OUTPORT, CM_FLOPPY_TYPE );
  floppy = inp ( CM_INPORT );

  printf("      First floppy drive : ");
  switch(  floppy >> 4  )
   {
    case 0x00:printf("no drive\r\n");
	      break;
    case 0x01:printf("5.25 360K\r\n");
	      break;
    case 0x02:printf("5.25 1.2Mb\r\n");
	      break;
    case 0x03:printf("3.5 720K\r\n");
	      break;
    case 0x04:printf("3.5 1.44Mb\r\n");
	      break;
      default:printf("unknown\r\n");
    }

  printf("     Second floppy drive : ");

  switch( floppy & 0x0F )
   {
    case 0x00:printf("no drive\r\n");
	      break;
    case 0x01:printf("5.25 360K\r\n");
	      break;
    case 0x02:printf("5.25 1.2Mb\r\n");
	      break;
    case 0x03:printf("3.5 720K\r\n");
	      break;
    case 0x04:printf("3.5 1.44Mb\r\n");
	      break;
      default:printf("unknown\r\n");
    }

  // get hard disk parameters
  outp ( CM_OUTPORT, CM_HARD_TYPE );
  hdbyte = inp ( CM_INPORT );

  if( ( hdbyte >> 4 ) >= 0x0F )
   {
    outp ( CM_OUTPORT, CM_1ST_HARD_EXTEN );
    hdext = inp ( CM_INPORT );
    printf("       Hard drive 1 type : %d\r\n", hdext);

   if( (hdext == 48 )|| (hdext == 49) ) get_ext_params ( CM_TYPE48_CYL_LO );
   }
   else
    printf("       Hard drive 1 type : %d\r\n",hdbyte >> 4);


  if( (hdbyte & 0x0F) >= 0x0F )
   {
    outp ( CM_OUTPORT, CM_2ND_HARD_EXTEN );
    hdext = inp ( CM_INPORT );
    printf("       Hard drive 2 type : %d\r\n", hdext);
   if( (hdext == 48 )|| (hdext == 49) ) get_ext_params ( CM_TYPE49_CYL_LO );
   }
   else
    printf("       Hard drive 2 type : %d\r\n",hdbyte & 0x0f);

   outp ( CM_OUTPORT, CM_BASEMEM_LO );
   basemem_lo = inp ( CM_INPORT );
   outp ( CM_OUTPORT, CM_BASEMEM_HI );
   basemem_hi = inp ( CM_INPORT );

    basemem = (basemem_hi << 8)+ basemem_lo;

   outp ( CM_OUTPORT, CM_EXTMEM_LO );
   extmem_lo = inp ( CM_INPORT );
   outp ( CM_OUTPORT, CM_EXTMEM_HI );
   extmem_hi = inp ( CM_INPORT );

    extmem = (extmem_hi << 8)+ extmem_lo;

    printf("             Base memory : %d kb\r\n",basemem);
    printf("         Extended memory : %d kb\r\n",extmem);

 return 0;
 }




 void get_ext_params(int port)
  {
    long int cyl_lo,cyl_hi, cyl;
	 int heads;
    long int precomp_lo,precomp_hi,precomp,
	     land_lo,land_hi,land;
	 int sectors;

  outp( CM_OUTPORT, port );
   cyl_lo = inp( CM_INPORT );
  outp( CM_OUTPORT, port + 1 );
   cyl_hi = inp( CM_INPORT );
  outp( CM_OUTPORT, port + 2 );
   heads = inp( CM_INPORT );
  outp( CM_OUTPORT, port + 3 );
   precomp_lo = inp( CM_INPORT );
  outp( CM_OUTPORT, port + 4 );
   precomp_hi = inp( CM_INPORT );
  outp( CM_OUTPORT, port + 5 );
   land_lo = inp( CM_INPORT );
  outp( CM_OUTPORT, port + 6 );
   land_hi = inp( CM_INPORT );
  outp( CM_OUTPORT, port + 7 );
   sectors = inp( CM_INPORT );

     cyl = (cyl_hi << 8) + cyl_lo;
     precomp = (precomp_hi << 8) + precomp_lo;
     land = (land_hi << 8 ) + land_lo;

     printf("               Cylinders : %ld\r\n", cyl);
     printf("                   Heads : %d\r\n", heads);
     printf("   Write Precompensation : %ld\r\n", precomp);
     printf("            Landing Zone : %ld\r\n", land);
     printf("    Sectors per Cylinder : %d\r\n\r\n", sectors);

  }




